import{world,system}from"@minecraft/server";
let{worldInitialize}=world.beforeEvents;
worldInitialize.subscribe(function(e){
e.blockComponentRegistry.registerCustomComponent('agg:spawn_structure',{
onTick:(i)=>{
const{x,y,z}=i.block.location;
system.runTimeout(()=>{
i.dimension.runCommandAsync(`structure load "agg+lab" ${x} ${y} ${z}`);
},1);
}
});
e.blockComponentRegistry.registerCustomComponent('agg:spawn_highway',{
onTick:(v)=>{
const{x,y,z}=v.block.location;
v.dimension.runCommandAsync(`structure load "agg+highwayUp" ${x} ${y} ${z}`);
}
});
e.blockComponentRegistry.registerCustomComponent("agg:u006f",{
onTick:(m)=>{
const{x,y,z}=m.block.location;
m.dimension.runCommandAsync(`execute positioned ${x} ${y} ${z} unless entity@e[r=5,type=agg:scientist] run summon agg:scientist`);
system.runTimeout(()=>{
m.dimension.runCommandAsync(`\u0073\u0065\u0074\u0062\u006c\u006f\u0063\u006b ${x} ${y} ${z} \u0061\u0069\u0072`);
},1);
}
});
});
world.afterEvents.entityHurt.subscribe(function(e){
const dmg=e.damageSource?.damagingEntity;
const hit=e.hurtEntity;
if(hit.typeId==='agg:professor')dmg?.addTag("target_professor");
else if(hit.typeId==='agg:scientist')dmg?.addTag("target_scientist");
else if(hit.typeId==='agg:spiky_hyena'){
dmg?.addTag('agg:s_hit');
system.runTimeout(function(){
hit.runCommand('damage @e[r=5,tag="agg:s_hit"] 10 entity_attack entity @s');
},1);
system.runTimeout(function(){
hit.removeTag("agg:s_hit");
},2);
}
});
world.afterEvents.itemUse.subscribe(function(e){
if(e.itemStack.typeId==='agg:lab_tracker'){
const{x,y,z}=e.source.location;
e.source.addEffect('minecraft:slowness',2,{amplifier:254,showParticles:false});
e.source.addEffect('minecraft:blindness',2,{amplifier:254,showParticles:false});
e.source.addEffect('minecraft:darkness',2,{amplifier:254,showParticles:false});
e.source.runCommand('structure load "agg+wlTrack" ~~~');
system.runTimeout(()=>e.source.runCommand(`setblock ${x} ${y} ${z} air`),1);
}});